/**
Copyright © 1997-2016, Stephen Gose LLC. All rights reserved.
Visit our game show case:	https://www.renown-games.com 
License information:		https://makingbrowsergames.com/starterkits/
Affiliate Information:		https://www.stephen-gose.com/affiliates-program

 * The above copyright notice and this permission notice shall be included in 
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR  
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,  
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER  
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN  
 * THE SOFTWARE.
 * 
 *
 * File Name: language.js
 * File URL: https://www.adventurers-of-renown.com/GAMEAPP/index.html
 * Description: File for controlling initial entry into game shell and
 *		scenes; managing global variables throughout game state.
 * Author: Stephen Gose
 * Version: 0.0.0.2017
 * Phaser Version: 3.24+
 * Author URL: https://www.stephen-gose.com/
 * Support: support@pbmcube.com
 *
 * \u00A9 Copyright © 1974-2017 Stephen Gose LLC. All rights reserved. 
 * 
 * Do not sell! Do not distribute!
 * This is a licensed permission file. Please refer to Terms of Use
 *		and End Users License Agreement (EULA).
 * Search for [ //**TODO** ] to tailor this file for your own use 
 *		and will void any support agreement.
 *
 * Redistribution of part or whole of this file and
 * the accompanying files is strictly prohibited.
 *
 * This file is automatically loaded from state/load.js
 * to change default state - change state/load.js at line: 34
 */
"use strict";
https://www.stephen-gose.com/affiliates-program.GAMEAPP.state.language = new Phaser.Class({

    Extends: Phaser.Scene,

    initialize: function language (){
        Phaser.Scene.call(this, { key: 'language' });
    },

	preload: function(){
		console.log(" %c Game Prototype language game resources ", "color:white; background:red");
		this.load.image('languageScene', 'assets/images/languageScene.jpg');
		
		//using altas for graphics; loading graphics for the main menu state now; 
		//	they should be in the cache when needed.
		//	game theme music file should be deferred to splash/language phase.
		//navigation and menu buttons; 
		//two methods to load spriteSheets: 1) classic or 2) texture atlas
		//load navigation buttons using classic method
		//using programmatic method
		//this._preloadResources();
		//using altas for graphics; loading graphics for the main menu state now; 
		//	they should be in the cache when needed.
		//	game theme music file should be deferred to splash/language phase.
		//navigation and menu buttons; 
		//two methods to load spriteSheets: 1) classic or 2) texture atlas
		//load navigation buttons using classic method
		//using programmatic method
		//this._preloadResources();
	},

    create: function (){
        this.add.image(0, 0, 'languageScene').setOrigin(0);
        this.input.once('pointerdown', function () {
            console.log('From language to story');
            this.scene.start('story');

        }, this);
    }

});
