/**
* Copyright  1997-2016, Stephen Gose LLC. All rights reserved.
* Visit our game show case:     https://www.renown-games.com 
* License information:          https://leanpub.com/mbg-memory
* Affiliate Information:		https://www.stephen-gose.com/affiliates-program
*
* The above copyright notice and this permission notice shall be included in 
* all copies or substantial portions of the Software.
* 
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR  
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,  
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER  
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN  
* THE SOFTWARE.
*
*
* File Name:    Credit.js
* License:		https://makingbrowsergames.com/starterkits/LICENSE.pdf
* File URL:     https://www.adventurers-of-renown.com/GAMEAPP/index.html
* Description: File for controlling game credits, recognitions, 
*		and sponsor recommendation.
* Author: Stephen Gose
* Version: 0.0.0.xx
* Phaser Version: 3.24+
* Author URL:   https://www.stephen-gose.com/
* Support: support@pbmcube.com
*
* \u00A9 Copyright   1974-2017 Stephen Gose LLC. All rights reserved. 
* 
* Do not sell! Do not distribute!
* This is a licensed file with EULA permission.
* Please refer to the Terms of Use
*   and End Users License Agreement (EULA).
*  
* Search for [ //TODO ] to tailor this file for your own use; 
*	 doing so will void any support agreement.
*
* Redistribution of part or whole of this file and
* the accompanying files is strictly prohibited.
*
* Reference:
* https://www.adequatelygood.com/JavaScript-Module-Pattern-In-Depth.html
*
*/
// =========================================================
"use strict";
/**	game credits menu **/
 
window.GAMEAPP.state.credits = {
	preload: function (){
		console.log(" %c xxxx rv_17 Game Prototype Credits Menu ", "color:white; background:red");
		GAMEAPP.InfoText = "Game Credits and Information";
		//credits and acknowledgments
		this.load.path = "assets/images/staticScenes/";	
		this.load.image('creditScene', 'creditsScene.jpg');	
		
		//using atlas for graphics; 
		//loading graphics for the main menu state now; 
		//	they should be in the cache when needed.
		//	game theme music file should be deferred to splash/language phase.
		//navigation and menu buttons; 
		//two methods to load spriteSheets: 1) classic or 2) texture atlas
		//load navigation buttons using classic method
		//using programmatic method
		
	},

	create: function () {
		this.add.image(config.width/2, config.height/2, 'creditScene');
		//return to main menu txt
		var tooltxt = this.add.text(config.width/2, config.height/2+30, GAMEAPP.gCredits, GAMEAPP.styleHUD);
		
		var textTitle = this.add.text(config.width/2, 145, "Credits & Help", GAMEAPP.styleHUD);

		textTitle.setOrigin(0.5, 0.5);
		textTitle.setShadow(3, 3, 'rgba(0,0,0,0.5)', 5);
		textTitle.fontWeight = 'bold';
		
		tooltxt.setOrigin(0.5, 0.5);
		tooltxt.setShadow(3, 3, 'rgba(0,0,0,0.5)', 5);
		tooltxt.fontWeight = 'bold';
			
		//Goto main menu
		var buttonContinue = this.add.sprite(700, 380, 'button-continue').setInteractive();
            buttonContinue.setFrame(2);
            buttonContinue.on('pointerover', function (pointer){
            console.info(buttonContinue.name + " over. ");
            //this._toolTip.setText("Return to Game"); 
            buttonContinue.setFrame(1);
		}, this);
		buttonContinue.on('pointerout', function (pointer){
            console.info(buttonContinue.name + " out. ");
            //this._toolTip.setText("Return to Game"); 
            buttonContinue.setFrame(2);
            }, this);
            buttonContinue.on('pointerdown',  function (pointer){
            console.info(buttonContinue.name + " clicked down. ");
            buttonContinue.setFrame(0);
		}, this);
		buttonContinue.on('pointerup',  function (pointer){
			console.log(buttonContinue.name + " click released.");
			buttonContinue.setFrame(2);

			this.scene.transition({
                    //target: "story",    // goes to story line
					target: "menu",
					duration: 150,
					sleep: false,		// true = to sleep current scene;   
										// false = to stop current scene
					moveAbove: true,	// move the target Scene above this current  
										// 	scene before the transition starts
					moveBelow: false,	// move the target Scene below this current  
					//onUpdate: GameReturn(),
					onUpdateScope: "menu"
                    //onUpdateScope: "story"
                    
				});
			}, this);
		
	},


	update: function () {

		

	}

};

//
// =========================================================
/* End of file */
/* Location: ./js/state/credits.js */

