/**
 * File Name: language.js
 * File URL: https://www.adventurers-of-renown.com/GAMEAPP/index.html
 * Description: File for controlling initial entry into game shell and
 *		scenes; managing global variables throughout game state.
 * Author: Stephen Gose
 * Version: 0.0.0.17
 * Phaser Version: 3.0.0
 * Author URL: https://www.stephen-gose.com/
 * Support: support@pbmcube.com
 *
 * Copyright © \u00A9 1974-2017 Stephen Gose LLC. All rights reserved. 
 * 
 * Do not sell! Do not distribute!
 * This is a licensed permission file. Please refer to Terms of Use
 *		and End Users License Agreement (EULA).
 * Search for [ //**TODO** ] to tailor this file for your own use 
 *		and will void any support agreement.
 *
 * Redistribution of part or whole of this file and
 * the accompanying files is strictly prohibited.
 *
 * This file is automatically loaded from state/load.js
 * to change default state - change state/load.js at line: 34
 */
"use strict";
window.GAMEAPP.state.language = {
	preload: function(){
		console.log(" %c Game Prototype language game resources ", "color:white; background:red");
		console.log("%c  Starting my awesome MMoG game Prototype!       \n  | https://shop.pbmcube.net/ |                    \n  | \u2665\u2665\u2665\u2665\u2665 -> $120 License included in book!      \n  | Book available at: https://leanpub.com/LoRD | ",
	"color:white; background:blue");
		
	//using altas for graphics; loading graphics for the main menu state now; 
	//	they should be in the cache when needed.
	//	game theme music file should be deferred to splash/language phase.
	//navigation and menu buttons; 
	//two methods to load spriteSheets: 1) classic or 2) texture atlas
	//load navigation buttons using classic method
	//using programmatic method
	//this._preloadResources();
	},
	
	create: function(){
		console.log("starting language selection state");
		this.add.image(400, 259, 'menus');
		this.cameras.main.setViewport(0, 0, 800, 518);
		/**
		//Language v2 buttons example - top row
		var china = this.game.add.button(this.world.centerX-110, this.world.centerY-50, 'chinaBtn', this.clickLangSelected, this, 1, 0, 2,0);
		china.name = "china";
		china.onInputOver.add(this.btnOver, this);
		china.inputEnabled = true;
		china.scale.setTo(0.9,0.9);
		*/
		//v3 buttons
		var china = this.add.sprite(290, 209, 'chinaBtn').setInteractive();
		china.name = "china";
		this.input.setOnOverCallback(china, v3onOver, this);
		this.input.setOnOutCallback(china, v3onOut, this);
		this.input.setOnDownCallback(china, v3onDown, this);
		this.input.setOnUpCallback(china, v3onUp, this);
		
		
		/**
		var dmark = this.game.add.button(this.world.centerX-60, this.world.centerY-50, 'dmarkBtn', this.clickLangSelected, this, 1, 0, 2,0);
		dmark.name = "denmark";
		dmark.onInputOver.add(this.btnOver, this);
		dmark.inputEnabled = true;
		dmark.scale.setTo(0.9,0.9);
		
		var english = this.game.add.button(this.world.centerX-10, this.world.centerY-50, 'englishBtn', this.clickLangSelected, this, 1, 0, 2,0);
		english.name = "english";
		english.onInputOver.add(this.btnOver, this);
		english.inputEnabled = true;
		english.scale.setTo(0.9,0.9);
		
		var french = this.game.add.button(this.world.centerX+40, this.world.centerY-50, 'frenchBtn', this.clickLangSelected, this, 1, 0, 2,0);
		french.name = "french";
		french.onInputOver.add(this.btnOver, this);
		french.inputEnabled = true;
		french.scale.setTo(0.9,0.9);
		
		var german = this.game.add.button(this.world.centerX+90, this.world.centerY-50, 'germanBtn', this.clickLangSelected, this, 1, 0, 2,0);
		german.name = "german";
		german.onInputOver.add(this.btnOver, this);
		german.inputEnabled = true;
		german.scale.setTo(0.9,0.9);
		
		var italy = this.game.add.button(this.world.centerX-160, this.world.centerY-50, 'italyBtn', this.clickLangSelected, this, 1, 0, 2,0);
		italy.name = "italy";
		italy.onInputOver.add(this.btnOver, this);
		italy.inputEnabled = true;
		italy.scale.setTo(0.9,0.9);
		
		//Language buttons - bottom row
		var nland = this.game.add.button(this.world.centerX-135, this.world.centerY+10, 'nlandBtn', this.clickLangSelected, this, 1, 0, 2,0);
		nland.name = "netherlands";
		nland.onInputOver.add(this.btnOver, this);
		nland.inputEnabled = true;
		nland.scale.setTo(0.9,0.9);
		
		var japan = this.game.add.button(this.world.centerX+65, this.world.centerY+10, 'japanBtn', this.clickLangSelected, this, 1, 0, 2,0);
		japan.name = "japan";
		japan.onInputOver.add(this.btnOver, this);
		japan.inputEnabled = true;
		japan.scale.setTo(0.9,0.9);
		
		var portugal = this.game.add.button(this.world.centerX+15, this.world.centerY+10, 'portugalBtn', this.clickLangSelected, this, 1, 0, 2,0);
		portugal.name = "portugal";
		portugal.onInputOver.add(this.btnOver, this);
		portugal.inputEnabled = true;
		portugal.scale.setTo(0.9,0.9);
		
		var spain = this.game.add.button(this.world.centerX-35, this.world.centerY+10, 'spainBtn', this.clickLangSelected, this, 1, 0, 2,0);
		spain.name = "spain";
		spain.onInputOver.add(this.btnOver, this);
		spain.inputEnabled = true;
		spain.scale.setTo(0.9,0.9);
		
		var sweden = this.game.add.button(this.world.centerX-85, this.world.centerY+10, 'swedenBtn', this.clickLangSelected, this, 1, 0, 2,0);
		sweden.name = "sweden";
		sweden.onInputOver.add(this.btnOver, this);
		sweden.inputEnabled = true;
		sweden.scale.setTo(0.9,0.9);
		//end v2 button
		*/
		/**
		//Goto main menu
		var buttonContinue = this.game.add.button(this.world.width, this.world.centerY+50, 'button-continue', this.clickContinue, this, 1, 0, 2,0);
		
		buttonContinue.anchor.set(1,1);
		buttonContinue.x = this.world.width+buttonContinue.width+20;
		*/
		
		//this.add.tween(buttonContinue).to({x: this.world.width-20}, 500, Phaser.Easing.Exponential.Out, true);

		/**
		this._toolTip = this.game.add.text(this.world.centerX, this.world.centerY-80, GAMEAPP.InfoText, GAMEAPP.styleRA);
		this._toolTip.anchor.set(0.5,0.5);
		this._toolTip.setShadow(3, 3, 'rgba(0,0,0,0.5)', 5);
		this._toolTip.fontWeight = 'bold';
		
		this.camera.flash(0x000000, 500, false);
		*/
	},
	
	update: function(){
		
	},
	
	/**
	//Begin v2 button over function
	btnOver: function(butn){
		switch(butn.name){
			case "china":
				GAMEAPP.gameLanguage = 1;
				console.log("Chinese selected");
				this._toolTip.setText("Chinese | 中文 "); 
				break;
			
			case "denmark":
				GAMEAPP.gameLanguage = 2;
				console.log("Danish selected");
				this._toolTip.setText("Danish | Dansk sprog "); 
				break;
			
			case "english":
				GAMEAPP.gameLanguage = 0;
				console.log("English selected");
				this._toolTip.setText("Default Language: English\n Select language then click arrow to enter."); 
				break;
			
			case "french":
				GAMEAPP.gameLanguage = 3;
				console.log("French selected");
				this._toolTip.setText("French | langue française "); 
				break;

			case "german":
				GAMEAPP.gameLanguage = 4;
				console.log("German selected");
				this._toolTip.setText("German | deutsche Sprache "); 
				break;	
				
			case "italy":
				GAMEAPP.gameLanguage = 5;
				console.log("Italian selected");
				this._toolTip.setText("Italian | lingua italiana "); 
				break;
			
			case "japan":
				GAMEAPP.gameLanguage = 6;
				console.log("Japanese selected");
				this._toolTip.setText("Japanese | 日本語 "); 
				break;
			
			case "netherlands":
				GAMEAPP.gameLanguage = 7;
				console.log("Dutch selected");
				this._toolTip.setText("Dutch | Nederlandse taal "); 
				break;
			
			case "portugal":
				GAMEAPP.gameLanguage = 8;
				console.log("Portuguese selected");
				this._toolTip.setText("Portuguese | idioma portugues "); 
				break;
			
			case "spain":
				GAMEAPP.gameLanguage = 9;
				console.log("Spanish selected");
				this._toolTip.setText("Spanish | língua espanhola "); 
				break;
			
			case "sweden":
				GAMEAPP.gameLanguage = 10;
				console.log("Swedish selected");
				this._toolTip.setText("Swedish | Svenska språket "); 
				break;
			
			default:
				console.log("English selected");
				GAMEAPP.gameLanguage = 0;
				this._toolTip.setText("Default Language: English\n Select language then click arrow to enter."); 
				break;
		}
	},
	*/
	//End of v2 button over
	
	clickContinue: function() {
		GAMEAPP._playAudio('click');
		this.camera.fade(0x000000, 200, false);
		this.time.events.add(200, function() {
			//this.game.state.start('Main');	//BBS & Flash website: TIGStart method
			this.game.state.start('story');		//ARRA Main Entrance rv_3 through rv_8
		}, this);
		
	},
	
	clickLangSelected: function() {
		GAMEAPP._assignLanguage(GAMEAPP.gameLanguage);
		GAMEAPP._playAudio('click');
		this.camera.fade(0x000000, 200, false);
		this.time.events.add(200, function() {
			//this.game.state.start('Main');	//BBS & Flash website: TIGStart method
			this.game.state.start('story');		//ARRA Main Entrance rv_3 through rv_8
		}, this);
		
	},
	
	_preloadResources() {
	var pack = this.resources;
		for(var method in pack) {
			pack[method].forEach(function(args) {
				var loader = this.load[method];
				loader && loader.apply(this.load, args);
			}, this);
		}
	}
};

//internal static; JSON game resources
this.resources = {
	'image':[
		['button', 'assets/spriteSheets/mmog-sprites-silver.png', 129, 30],
		['menus', 'assets/images/staticRooms/arra15Options.jpg'],
		['combat', 'assets/images/staticRooms/combat.jpg'],
		['Inventory', 'assets/images/staticRooms/inventory.jpg'],
		['R1', 'assets/images/staticRooms/R1.jpg'],
		['R6', 'assets/images/staticRooms/R6.jpg']
	],
	'spritesheet':[
		['button', 'assets/spriteSheets/mmog-sprites-silver.png', 129, 30]
		
	],
	'atlas':[
		['langButton','assets/images/flags/language.png','assets/images/flags/language.json'],
		['soundButton','assets/spriteSheets/soundButton.png','assets/spriteSheets/mmm-soundButton.json'],
		['button-continue','assets/spriteSheets/RightArrow-Phaser.png','assets/spriteSheets/arrowR-sprites.json'],
		['aboutUsButton','assets/spriteSheets/mmog-sprites-silver.png','assets/spriteSheets/mmog-sprites.json'],
		['creditButton','assets/spriteSheets/mmog-sprites-silver.png','assets/spriteSheets/mmog-sprites.json'],
		['donaButton','assets/spriteSheets/mmog-sprites-silver.png','assets/spriteSheets/mmog-sprites.json'],
		['gameOverButton','assets/spriteSheets/mmog-sprites-silver.png','assets/spriteSheets/mmog-sprites.json'],
		['helpButton','assets/spriteSheets/mmog-sprites-silver.png','assets/spriteSheets/mmog-sprites.json'],
		['moreButton','assets/spriteSheets/mmog-sprites-silver.png','assets/spriteSheets/mmog-sprites.json'],
		['optButton','assets/spriteSheets/mmog-sprites-silver.png','assets/spriteSheets/mmog-sprites.json'],
		['playButton','assets/spriteSheets/mmog-sprites-silver.png','assets/spriteSheets/mmog-sprites.json'],
		['scoresButton','assets/spriteSheets/mmog-sprites-silver.png','assets/spriteSheets/mmog-sprites.json'],
		['shareButton','assets/spriteSheets/mmog-sprites-silver.png','assets/spriteSheets/mmog-sprites.json'],
		['webButton','assets/spriteSheets/mmog-sprites-silver.png','assets/spriteSheets/mmog-sprites.json'],
		['ARRADeath','assets/spriteSheets/ARRADeath/ARRADeath.png','assets/spriteSheets/ARRADeath/ARRADeath.json'],
		['avatar','assets/icons/arraIcons.png','assets/icons/arraIcons.json'],
		['doorButton','assets/images/doors/Doors.png','assets/images/doors/Doors.json']
		
	],
	'audio':[
		['audio-theme',['assets/audio/yewtree.mp3','assets/audio/yewtree.ogg']]
	]
};

function v3onOver(gameObject,pointer, x,y){
		gameObject.setScale(1.25);
		//gameObject.x -= 2;
		//gameObject.y -= 2;
	};
	
function v3onOut(gameObject,pointer, x,y){
		gameObject.setScale(1);
		//gameObject.x += 2;
		//gameObject.y += 2;
	};

function v3onUp(gameObject,pointer, x,y){
		gameObject.setScale(1);
		//gameObject.x += 2;
		//gameObject.y += 2;
	};
	
function v3onDown (gameObject, pointer, x, y)
{
    gameObject.setScale(.6);
	//gameObject.x += 2;
	//gameObject.y += 2;
	
};

function v3onUp (gameObject, pointer, x, y)
{
    console.log(gameObject.name+" clicked");
}