/**
Copyright © 1997-2016, Stephen Gose LLC. All rights reserved.
Visit our game show case:	https://www.renown-games.com 
License information:		https://makingbrowsergames.com/starterkits/
Affiliate Information:		https://www.stephen-gose.com/affiliates-program/

 * The above copyright notice and this permission notice shall be included in 
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR  
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,  
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER  
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN  
 * THE SOFTWARE.
 * 
 *
 * File Name: language.js
 * File URL: https://www.adventurers-of-renown.com/GAMEAPP/index.html
 * Description: File for controlling initial entry into game shell and
 *		scenes; managing global variables throughout game state.
 * Author: Stephen Gose
 * Version: 0.0.0.2017
 * Phaser Version: 3.15.x+
 * Author URL: https://www.stephen-gose.com/
 * Support: support@pbmcube.com
 *
 * \u00A9 Copyright © 1974-2017 Stephen Gose LLC. All rights reserved. 
 * 
 * Do not sell! Do not distribute!
 * This is a licensed permission file. Please refer to Terms of Use
 *		and End Users License Agreement (EULA).
 * Search for [ //**TODO** ] to tailor this file for your own use 
 *		and will void any support agreement.
 *
 * Redistribution of part or whole of this file and
 * the accompanying files is strictly prohibited.
 *
 * This file is automatically loaded from state/load.js
 * to change default state - change state/load.js at line: 34
 */
"use strict";
window.GAMEAPP.state.language = {
	preload: function(){
		console.log(" %c Game Prototype language game resources ", "color:white; background:red");
		this.load.image('langScene', 'assets/images/languageScene.jpg');
		
		//using altas for graphics; loading graphics for the main menu state now; 
		//	they should be in the cache when needed.
		//	game theme music file should be deferred to splash/language phase.
		//navigation and menu buttons; 
		//two methods to load spriteSheets: 1) classic or 2) texture atlas
		//load navigation buttons using classic method
		//using programmatic method
		//this._preloadResources();
	},
	
	create: function(){
		console.log("starting language selection state");
		this.add.image(config.width/2, config.height/2, 'langScene');
		this.cameras.main.setViewport(0, 0, config.width, config.height);

		//v3 buttons
		var chinaBtn = this.add.sprite(config.width/2-140, 200, 'chinaBtn').setInteractive();
		chinaBtn.name = "china";
		chinaBtn.on('pointerover', function (pointer){
			console.info(chinaBtn.name + " over. ");
			this._toolTip.setText("Chinese | 中文 "); 
			chinaBtn.setFrame(1);
		}, this);
		chinaBtn.on('pointerout', function (pointer){
		console.info(chinaBtn.name + " out. ");
		this._toolTip.setText("");
		chinaBtn.setFrame(0);
		}, this);
		chinaBtn.on('pointerdown',  function (pointer){
		console.info(chinaBtn.name + " clicked down. ");
		chinaBtn.setFrame(2);
		}, this);
		chinaBtn.on('pointerup',  function (pointer){
		console.log(chinaBtn.name + " click released.");
		GAMEAPP.gameLanguage = 1;
		chinaBtn.setFrame(0);
		}, this);

		var dmarkBtn = this.add.sprite(config.width/2-30, 200, 'dmarkBtn').setInteractive();
		dmarkBtn.name = "denmark";
		dmarkBtn.on('pointerover', function (pointer){
		console.info(dmarkBtn.name + " over. ");
		this._toolTip.setText("Danish | Dansk sprog "); 
		dmarkBtn.setFrame(1);
		}, this);
		dmarkBtn.on('pointerout', function (pointer){
		console.info(dmarkBtn.name + " out. ");
		this._toolTip.setText("");
		dmarkBtn.setFrame(0);
		}, this);
		dmarkBtn.on('pointerdown',  function (pointer){
		console.info(dmarkBtn.name + " clicked down. ");
		dmarkBtn.setFrame(2);
		}, this);
		dmarkBtn.on('pointerup',  function (pointer){
		console.log(dmarkBtn.name + " click released.");
		GAMEAPP.gameLanguage = 2;
		dmarkBtn.setFrame(0);
		}, this);

		var englishBtn = this.add.sprite(config.width/2+27, 200, 'englishBtn').setInteractive();
		englishBtn.name = "english";
		englishBtn.on('pointerover', function (pointer){
		console.info(englishBtn.name + " over. ");
		this._toolTip.setText("Default Language: English\n Select language then click arrow to enter."); 
		englishBtn.setFrame(1);
		}, this);
		englishBtn.on('pointerout', function (pointer){
		console.info(englishBtn.name + " out. ");
		englishBtn.setFrame(0);
		this._toolTip.setText("");
		}, this);
		englishBtn.on('pointerdown',  function (pointer){
		console.info(englishBtn.name + " clicked down. ");
		englishBtn.setFrame(2);
		}, this);
		englishBtn.on('pointerup',  function (pointer){
		console.log(englishBtn.name + " click released.");
		GAMEAPP.gameLanguage = 0;
		englishBtn.setFrame(0);
		}, this);

		var frenchBtn = this.add.sprite(config.width/2+85, 200, 'frenchBtn').setInteractive();
		frenchBtn.name = "french";
		frenchBtn.on('pointerover', function (pointer){
		console.info(frenchBtn.name + " over. ");
		this._toolTip.setText("French | langue française "); 
		frenchBtn.setFrame(1);
		}, this);
		frenchBtn.on('pointerout', function (pointer){
		console.info(frenchBtn.name + " out. ");
		this._toolTip.setText("");
		frenchBtn.setFrame(0);
		}, this);
		frenchBtn.on('pointerdown',  function (pointer){
		console.info(frenchBtn.name + " clicked down. ");
		frenchBtn.setFrame(2);
		}, this);
		frenchBtn.on('pointerup',  function (pointer){
		console.log(frenchBtn.name + " click released.");
		GAMEAPP.gameLanguage = 3;
		frenchBtn.setFrame(0);
		}, this);

		var germanBtn = this.add.sprite(config.width/2+145, 200, 'germanBtn').setInteractive();
		germanBtn.name = "german";
		germanBtn.on('pointerover', function (pointer){
		console.info(germanBtn.name + " over. ");
		this._toolTip.setText("German | deutsche Sprache "); 
		germanBtn.setFrame(1);
		}, this);
		germanBtn.on('pointerout', function (pointer){
		console.info(germanBtn.name + " out. ");
		this._toolTip.setText("");
		germanBtn.setFrame(0);
		}, this);
		germanBtn.on('pointerdown',  function (pointer){
		console.info(germanBtn.name + " clicked down. ");
		germanBtn.setFrame(2);
		}, this);
		germanBtn.on('pointerup',  function (pointer){
		console.log(germanBtn.name + " click released.");
		GAMEAPP.gameLanguage = 4;
		germanBtn.setFrame(0);
		}, this);

		var italyBtn = this.add.sprite(config.width/2-85, 200, 'italyBtn').setInteractive();
		italyBtn.name = "italy";
		italyBtn.on('pointerover', function (pointer){
		console.info(italyBtn.name + " over. ");
		this._toolTip.setText("Italian | lingua italiana "); 
		italyBtn.setFrame(1);
		}, this);
		italyBtn.on('pointerout', function (pointer){
		console.info(italyBtn.name + " out. ");
		this._toolTip.setText("");
		italyBtn.setFrame(0);
		}, this);
		italyBtn.on('pointerdown',  function (pointer){
		console.info(italyBtn.name + " clicked down. ");
		italyBtn.setFrame(2);
		}, this);
		italyBtn.on('pointerup',  function (pointer){
		console.log(italyBtn.name + " click released.");
		GAMEAPP.gameLanguage = 5;
		italyBtn.setFrame(0);
		}, this);

		//Language buttons - bottom row
		var nlandBtn = this.add.sprite(config.width/2-115, 270, 'nlandBtn').setInteractive();
		nlandBtn.name = "netherlands";
		nlandBtn.on('pointerover', function (pointer){
		console.info(nlandBtn.name + " over. ");
		this._toolTip.setText("Dutch | Nederlandse taal "); 
		nlandBtn.setFrame(1);
		}, this);
		nlandBtn.on('pointerout', function (pointer){
		console.info(nlandBtn.name + " out. ");
		this._toolTip.setText("");
		nlandBtn.setFrame(0);
		}, this);
		nlandBtn.on('pointerdown',  function (pointer){
		console.info(nlandBtn.name + " clicked down. ");
		nlandBtn.setFrame(2);
		}, this);
		nlandBtn.on('pointerup',  function (pointer){
		console.log(nlandBtn.name + " click released.");
		GAMEAPP.gameLanguage = 7;
		nlandBtn.setFrame(0);
		}, this);

		var japanBtn = this.add.sprite(config.width/2+115, 270, 'japanBtn').setInteractive();
		japanBtn.name = "japan";
		japanBtn.on('pointerover', function (pointer){
		console.info(japanBtn.name + " over. ");
		this._toolTip.setText("Japanese | 日本語 "); 
		japanBtn.setFrame(1);
		}, this);
		japanBtn.on('pointerout', function (pointer){
		console.info(japanBtn.name + " out. ");
		this._toolTip.setText("");
		japanBtn.setFrame(0);
		}, this);
		japanBtn.on('pointerdown',  function (pointer){
		console.info(japanBtn.name + " clicked down. ");
		japanBtn.setFrame(2);
		}, this);
		japanBtn.on('pointerup',  function (pointer){
		console.log(japanBtn.name + " click released.");
		GAMEAPP.gameLanguage = 6;
		japanBtn.setFrame(0);
		}, this);

		var portugalBtn = this.add.sprite(config.width/2+57, 270, 'portugalBtn').setInteractive();
		portugalBtn.name = "portugal";
		portugalBtn.on('pointerover', function (pointer){
		console.info(portugalBtn.name + " over. ");
		this._toolTip.setText("Portuguese | idioma portugues "); 
		portugalBtn.setFrame(1);
		}, this);
		portugalBtn.on('pointerout', function (pointer){
		console.info(portugalBtn.name + " out. ");
		this._toolTip.setText("");
		portugalBtn.setFrame(0);
		}, this);
		portugalBtn.on('pointerdown',  function (pointer){
		console.info(portugalBtn.name + " clicked down. ");
		portugalBtn.setFrame(2);
		}, this);
		portugalBtn.on('pointerup',  function (pointer){
		console.log(portugalBtn.name + " click released.");
		GAMEAPP.gameLanguage = 8;
		portugalBtn.setFrame(0);
		}, this);

		var spainBtn = this.add.sprite(config.width/2, 270, 'spainBtn').setInteractive();
		spainBtn.name = "spain";
		spainBtn.on('pointerover', function (pointer){
		console.info(spainBtn.name + " over. ");
		this._toolTip.setText("Spanish | língua espanhola "); 
		spainBtn.setFrame(1);
		}, this);
		spainBtn.on('pointerout', function (pointer){
		console.info(spainBtn.name + " out. ");
		this._toolTip.setText("");
		spainBtn.setFrame(0);
		}, this);
		spainBtn.on('pointerdown',  function (pointer){
		console.info(spainBtn.name + " clicked down. ");
		spainBtn.setFrame(2);
		}, this);
		spainBtn.on('pointerup',  function (pointer){
		console.log(spainBtn.name + " click released.");
		GAMEAPP.gameLanguage = 9;
		spainBtn.setFrame(0);
		}, this);

		var swedenBtn = this.add.sprite(config.width/2-57, 270, 'swedenBtn').setInteractive();
		swedenBtn.name = "sweden";
		swedenBtn.on('pointerover', function (pointer){
			console.info(swedenBtn.name + " over. ");
			this._toolTip.setText("Swedish | Svenska språket "); 
			swedenBtn.setFrame(1);
			}, this);
		swedenBtn.on('pointerout', function (pointer){
			console.info(swedenBtn.name + " out. ");
			this._toolTip.setText(""); 
			swedenBtn.setFrame(0);
			}, this);
		swedenBtn.on('pointerdown',  function (pointer){
			console.info(swedenBtn.name + " clicked down. ");
			swedenBtn.setFrame(2);
			}, this);
		swedenBtn.on('pointerup',  function (pointer){
			console.log(swedenBtn.name + " click released.");
			GAMEAPP.gameLanguage = 10;
			swedenBtn.setFrame(0);
			}, this);
		//end v3 button
		
		
		//Goto main menu
		var buttonContinue = this.add.sprite(config.width-100, config.height/2, 'button-continue').setInteractive();
		buttonContinue.setFrame(2);
		buttonContinue.on('pointerover', function (pointer){
			console.info(buttonContinue.name + " over. ");
			this._toolTip.setText("Start Game"); 
			buttonContinue.setFrame(1);
			}, this);
		buttonContinue.on('pointerout', function (pointer){
			console.info(buttonContinue.name + " out. ");
			this._toolTip.setText("Start Game"); 
			buttonContinue.setFrame(2);
			}, this);
		buttonContinue.on('pointerdown',  function (pointer){
			console.info(buttonContinue.name + " clicked down. ");
			buttonContinue.setFrame(0);
			}, this);
		buttonContinue.on('pointerup',  function (pointer){
			console.log(buttonContinue.name + " click released.");
			buttonContinue.setFrame(2);

			this.scene.transition({
                    target: "story",    // goes to story line
					//target: "menu",
					duration: 150,
					sleep: false,		// true = to sleep current scene;   
										// false = to stop current scene
					moveAbove: true,	// move the target Scene above this current  
										// 	scene before the transition starts
					moveBelow: false,	// move the target Scene below this current  
					//onUpdate: GameReturn(),
					//onUpdateScope: "menu"
                    onUpdateScope: "story"
				});
			}, this);

		
		this._toolTip = this.add.text(config.width/2, config.height-150, GAMEAPP.InfoText, GAMEAPP.styleHUD2);
		this._toolTip.setOrigin(0.5,0.5);
		this._toolTip.setShadow(5, 5, 'rgba(0,0,0,0.5)', 5);

		//Game Title stored in Phaser3 game.config
		this.gTitle = this.add.text(config.width/2,config.height/2-180, GAMEAPP.gameTitle, GAMEAPP.styleTitle);
		this.gTitle.setOrigin(0.5,0.5);
		this.gTitle.setShadow(3, 3, 'rgba(0,0,0,0.5)', 5);
		this.gTitle.fontWeight = 'bold';
		//-----
		//Game SubTitle stored in Phaser3 game.config
		this.gSubTitle = this.add.text(config.width/2,config.height/2-130, GAMEAPP.subTitle, GAMEAPP.styleSubTitle);
		this.gSubTitle.setOrigin(0.5,0.5);
		this.gSubTitle.setShadow(3, 3, 'rgba(0,0,0,0.5)', 5);
		//-----
		//Setup Copyright notice:
		// create dynamically updated year on notice
		var d = new Date();			//get JavaScript Date
		var n = d.getFullYear();	//get full year
		//Design Note: ( C ) is NOT a legal copyright notice
		// read more on proper copyright notices in
		// Phaser Game Design Workbook available at
		// https://leanpub.com/phaserjsgamedesignworkbook
		var Copr = this.add.text(config.width/2, config.height-20,"Copyright \u00A9 1974-"+n+", Stephen Gose. All rights reserved.\n Mozart Music Match™ is a service mark of Stephen Gose LLC.",GAMEAPP.styleCopr);
		Copr.setOrigin(0.5, 0.5);
		Copr.setShadow(3, 3, 'rgba(0,0,0,0.5)', 5);
		

	},
	
	update: function(){
		
	},
	
	clickLangSelected: function() {
		GAMEAPP._assignLanguage(GAMEAPP.gameLanguage);
		//GAMEAPP._playAudio('click');
		// fade camera in Phaser III
		this.cameras.main.fade(1500, 255, 255, 255);
		// restart game in Phaser III
		this.cameras.main.on('camerafadeoutcomplete', function () {
		console.log("Game Options launched.");
		GAMEAPP.game.scene.stop("language").sendToBack();
		//this.game.state.start('Main');	//BBS & Flash website: TIGStart method
		GAMEAPP.game.scene.start('story').bringToTop();
		}, this);
		
	},
	
	_preloadResources() {
	var pack = this.resources;
		for(var method in pack) {
			pack[method].forEach(function(args) {
				var loader = this.load[method];
				loader && loader.apply(this.load, args);
			}, this);
		}
	}	//place " , " If using more supporting function below
};

//internal static; JSON game resources
this.resources = {
	'image':[
		['button', 'assets/spriteSheets/mmog-sprites-silver.png', 129, 30],
		['menus', 'assets/images/staticRooms/arra15Options.jpg'],
		['combat', 'assets/images/staticRooms/combat.jpg'],
		['Inventory', 'assets/images/staticRooms/inventory.jpg'],
		['R1', 'assets/images/staticRooms/R1.jpg'],
		['R6', 'assets/images/staticRooms/R6.jpg']
	],
	'spritesheet':[
		['button', 'assets/spriteSheets/mmog-sprites-silver.png', 129, 30]
		
	],
	'atlas':[
		['langButton','assets/images/flags/language.png','assets/images/flags/language.json'],
		['soundButton','assets/spriteSheets/soundButton.png','assets/spriteSheets/mmm-soundButton.json'],
		['button-continue','assets/spriteSheets/RightArrow-Phaser.png','assets/spriteSheets/arrowR-sprites.json'],
		['aboutUsButton','assets/spriteSheets/mmog-sprites-silver.png','assets/spriteSheets/mmog-sprites.json'],
		['creditButton','assets/spriteSheets/mmog-sprites-silver.png','assets/spriteSheets/mmog-sprites.json'],
		['donaButton','assets/spriteSheets/mmog-sprites-silver.png','assets/spriteSheets/mmog-sprites.json'],
		['gameOverButton','assets/spriteSheets/mmog-sprites-silver.png','assets/spriteSheets/mmog-sprites.json'],
		['helpButton','assets/spriteSheets/mmog-sprites-silver.png','assets/spriteSheets/mmog-sprites.json'],
		['moreButton','assets/spriteSheets/mmog-sprites-silver.png','assets/spriteSheets/mmog-sprites.json'],
		['optButton','assets/spriteSheets/mmog-sprites-silver.png','assets/spriteSheets/mmog-sprites.json'],
		['playButton','assets/spriteSheets/mmog-sprites-silver.png','assets/spriteSheets/mmog-sprites.json'],
		['scoresButton','assets/spriteSheets/mmog-sprites-silver.png','assets/spriteSheets/mmog-sprites.json'],
		['shareButton','assets/spriteSheets/mmog-sprites-silver.png','assets/spriteSheets/mmog-sprites.json'],
		['webButton','assets/spriteSheets/mmog-sprites-silver.png','assets/spriteSheets/mmog-sprites.json'],
		['ARRADeath','assets/spriteSheets/ARRADeath/ARRADeath.png','assets/spriteSheets/ARRADeath/ARRADeath.json'],
		['avatar','assets/icons/arraIcons.png','assets/icons/arraIcons.json'],
		['doorButton','assets/images/doors/Doors.png','assets/images/doors/Doors.json']
		
	],
	'audio':[
		['audio-theme',['assets/audio/yewtree.mp3','assets/audio/yewtree.ogg']]
	]
};

//
// =========================================================
/* End of file */
/* Location: ./js/state/language.js */