/**
 * File Name: story.js
 * File URL: https://www.adventurers-of-renown.com/GAMEAPP/index.html
 * Description: File for background story and instructions.
 * Author: Stephen Gose
 * Version: 0.0.0.xx
 * Phaser Version: 3.x.x
 * Author URL: https://www.stephen-gose.com/
 * Support: support@pbmcube.com
 *
 * \u00A9 Copyright ©  1974-2017 Stephen Gose LLC. All rights reserved. 
 * 
 * Do not sell! Do not distribute!
 * This is a licensed file with EULA permission.
 * Please refer to the Terms of Use
 *   and End Users License Agreement (EULA).
 *  
 * Search for [ //TODO ] to tailor this file for your own use; 
 *	 doing so will void any support agreement.
 *
 * Redistribution of part or whole of this file and
 * the accompanying files is strictly prohibited.
 *
 * Reference:
 * https://www.adequatelygood.com/JavaScript-Module-Pattern-In-Depth.html
 *
 */
// 
// =========================================================
"use strict";
/**	game story & background **/

// 
// =========================================================
//AR: NCC Padora story generator
var plotType = [	
    "Your story is ...",
    "Your tale begins this way ...",
    "Here's how your new Quest begins ...",
    "Here's what happened ...",
    "Once upon a time in a galaxy far far away ..."

	];
// 
// =========================================================
var authorityFigure = [
    "You are brilliant, yet infamous, rogue merchant smuggler escaping the local star system within the",  
    "You are a Space Marine warrior transferring to a new duty station in the",  
    "You are a quality assurance scientist assigned to monitor the",  
    "You are a cargo merchant travelling to the",  
    "You are an engineering student transferring to the University in the",  
    "You are a pious and powerful cleric on an inquisition mission to the",
    "You are a powerful legendary Jedi sensing something unusal in the",  
    "You are a rich consultant seeking to advise business in the",  
    "Your are a chancellor/advisor of the local lord on assignment to the",  
    "You are the head of the local adventurer's guild auditing chapters based in the", 
    "You are the local captain of the guard on escort duty to the",   
];  
var greekNames = [
	"Acantha",
	"Achilles",
	"Adonis",
	"Adrastea",
	"Adrastos",
	"Aegle",
	"Aella",
	"Agaue",
	"Aiolos",
	"Alekto",
	"Althea",
	"Cassandra",
	"Castor",
	"Chloe",
	"Damon",
	"Daphne",
	"Dardanos",
	"Epimetheus",
	"Europa",
	"Nemesis",
	"Oedipus",
	"Pegasus"

];

var greekLetters = [	
    "Alpha",  
    "Beta",  
    "Gamma",
	"Delta",
	"Epsilon",
	"Zeta",
	"Eta",
	"Theta",
	"Iota",
	"Kappa",
	"Lambda",
	"Mu",
	"Nu",
	"Xi",
	"Omicron",
	"Pi",
	"Rho",
	"Sigma",
	"Tau",
	"Upsilon",
	"Phi",
	"Chi",
	"Psi",
	"Omega",
    
];  
// 
// =========================================================
window.GAMEAPP.state.story = {
	preload: function(){
		console.log(" %c ARxx rv_17 Story & Main Menu Game Prototype", "color:white; background:red");
		//GAMEAPP.InfoText = "Main Menu Selections";
		this.load.image('storyScene', 'assets/images/staticScenes/storyScene.jpg');
		//ARxx mainMenu & Story collapse into one scene
		this.load.spritesheet('button', 'assets/spriteSheets/mmog-sprites-silver.png', 129, 30);
		//GAMEAPP._assignLanguage(GAMEAPP.gameLanguage);
		//using altas for graphics; loading graphics for the main menu state now; 
		//	they should be in the cache when needed.
		//	game theme music file should be deferred to splash/language phase.
		//navigation and menu buttons; 
		//two methods to load spriteSheets: 1) classic or 2) texture atlas
		//load navigation buttons using classic method
		//using programmatic method
		//this._preloadResources();
	},
	
	create: function(){
		console.log("starting story line & Main Menu state");
		this.input.setGlobalTopOnly(true);
		this.add.image(config.width/2, config.height/2, 'storyScene');		
		var style = {};

		if (GAMEAPP.gameLanguage == 0) {
			
			style = { font: "12px Arial", fill: "#F90", align: "center", boundsAlignH: "left", boundsAlignV: "top", wordWrap: true, wordWrapWidth: 245 };
			this.introParatxt = this.add.text(config.width/3,config.height -150, GAMEAPP.introPara, style);
			this.introParatxt.setShadow(3, 3, 'rgba(0,0,0,0.5)', 5);
			//this.introParatxt.setTextBounds(555, 70, 780, 400);
			this.introParatxt.fontWeight = 'bold';
		}else{
			
			// the alignment of the text is independent of the bounds, try changing to 'center' or 'right'
			style = { font: "14px Arial", fill: "#F00", align: "center", boundsAlignH: "left", boundsAlignV: "top", wordWrap: true, wordWrapWidth: 230 };
			this.introParatxt = this.add.text(config.width/3,config.height -150, GAMEAPP.introPara, style);
			this.introParatxt.setShadow(3, 3, 'rgba(0,0,0,0.5)', 5);
			//this.introParatxt.setTextBounds(550, 138, 780, 400);
			this.introParatxt.fontWeight = 'bold';
		}
		
		
		//displayCanvas0();
		var Legend = "";
		var format = Math.floor(Math.random()*plotType.length);;  
		var authfig = Math.floor(Math.random()*authorityFigure.length); 
		var destination = Math.floor(Math.random()*greekLetters.length); 
		var transit = Math.floor(Math.random()*greekLetters.length);
		var star = Math.floor(Math.random()*greekLetters.length);	
		var computer = Math.floor(Math.random()*greekNames.length); 
	
	
        console.log("Story Narrative: ");  //debug
        console.log("     "+plotType[format]+" "+authorityFigure[authfig]+" "+greekLetters[destination]+" quadrant. You have secured a government seating on the NCC Pandora ( a scientific research vessel ). Its final destination is the "+greekLetters[transit]+" quadrant; fortunately, it must pass through the "+greekLetters[destination]+" quadrant. \n\n Unknown to you is the NCC Pandora had recently upgraded their navigation system and ship computers on their "+greekNames[destination]+"-"+greekLetters[destination]+"-"+Math.floor(Math.random()*6)+" operating system. Due to a small minut computational error, the NCC Pandora crossed dangerously close to the "+greekLetters[star]+"-"+Math.floor(Math.random()*16)+" star which dirupted all the vessel's computer systems. \n\n You awake from stasis to learn of the ship-wide system shutdown in 30 minutes. Your goal is to find all six ship's computers, manually defrag their memory content sufficiently to survive a full system reboot on each system.");  //debug
		var str = "     "+plotType[format]+" "+authorityFigure[authfig]+" "+greekLetters[destination]+" quadrant. You have secured a government seating on the NCC Pandora ( a scientific research vessel ). Its final destination is the "+greekLetters[transit]+" quadrant; fortunately, it must pass through the "+greekLetters[destination]+" quadrant. \n     Unknown to you is the NCC Pandora had recently upgraded their navigation system and ship computers on their "+greekNames[destination]+"-"+greekLetters[destination]+"-"+Math.floor(Math.random()*6)+" operating system. Due to a small minut computational error, the NCC Pandora crossed dangerously close to the "+greekLetters[star]+"-"+Math.floor(Math.random()*16)+" star which disrupted all the vessel's computer systems. \n     You awake from stasis to learn of the ship-wide system shutdown in 30 minutes. Your goal is to find all six ship's computers, manually defrag their memory content sufficiently to survive a full system reboot on each system. \n";
		 
		//Game Title stored in Phaser3 game.config
		this.gTitle = this.add.text(config.width/2,config.height/2-180, GAMEAPP.gameTitle, GAMEAPP.styleTitle);
		this.gTitle.setOrigin(0.5,0.5);
		this.gTitle.setShadow(3, 3, 'rgba(0,0,0,0.5)', 5);
		this.gTitle.fontWeight = 'bold';
		//-----
		//Game SubTitle stored in Phaser3 game.config
		this.gSubTitle = this.add.text(config.width/2,config.height/2-130, GAMEAPP.subTitle, GAMEAPP.styleSubTitle);
		this.gSubTitle.setOrigin(0.5,0.5);
		this.gSubTitle.setShadow(3, 3, 'rgba(0,0,0,0.5)', 5);
		//-----
		//Setup Copyright notice:
		// create dynamically updated year on notice
		var d = new Date();			//get JavaScript Date
		var n = d.getFullYear();	//get full year
		//Design Note: ( C ) is NOT a legal copyright notice
		// read more on proper copyright notices in
		// Phaser Game Design Workbook available at
		// https://leanpub.com/phaserjsgamedesignworkbook
		var Copr = this.add.text(config.width/2, config.height-20,"Copyright \u00A9 1974-"+n+", Stephen Gose. All rights reserved.\n Rogue Prince™ is a service mark of Stephen Gose LLC.",GAMEAPP.styleCopr);
		Copr.setOrigin(0.5, 0.5);
		Copr.setShadow(3, 3, 'rgba(0,0,0,0.5)', 5);
		
		//Goto main menu
		var buttonContinue2 = this.add.sprite(config.width-100, config.height-60, 'button-continue').setInteractive();
		buttonContinue2.setFrame(2);
		buttonContinue2.on('pointerover', function (pointer){
			console.info(buttonContinue2.name + " over. ");
			//this._toolTip.setText("Start Game"); 
			buttonContinue2.setFrame(1);
			}, this);
		buttonContinue2.on('pointerout', function (pointer){
			console.info(buttonContinue2.name + " out. ");
			//this._toolTip.setText("Start Game"); 
			buttonContinue2.setFrame(2);
			}, this);
		buttonContinue2.on('pointerdown',  function (pointer){
			console.info(buttonContinue2.name + " clicked down. ");
			buttonContinue2.setFrame(0);
			}, this);
		buttonContinue2.on('pointerup',  function (pointer){
			console.log(buttonContinue2.name + " click released.");
			buttonContinue2.setFrame(2);
			this.scene.transition({
                    //target: "story",    // goes to story line
					target: "menu",
					duration: 150,
					sleep: false,		// true = to sleep current scene;   
										// false = to stop current scene
					moveAbove: true,	// move the target Scene above this current  
										// 	scene before the transition starts
					moveBelow: false,	// move the target Scene below this current  
					//onUpdate: GameReturn(),
					onUpdateScope: "menu"
                    //onUpdateScope: "story"
				});
			}, this);

		
		this._toolTip = this.add.text(20, config.height/2-140, "The Story thus far ... \n"+str, GAMEAPP.styleStory);
		//similar to styleHUD2
		this._toolTip.wordWrap = true;
		this._toolTip.wordWrapWidth =500;
		this._toolTip.setOrigin(0,0);
		this._toolTip.setShadow(3, 3, 'rgba(0,0,0,0.5)', 5);
		this._toolTip.fontWeight = 'bold';
		
	},
	
};
	// 
	// =========================================================
function clickContinue2 () {

		/**
		// fade camera in Phaser III
		game.cameras.main.fade(1500, 255, 255, 255);
		// restart game in Phaser III
		this.cameras.main.on('camerafadeoutcomplete', function () {
		console.log("Game Options launched.");
		GAMEAPP.game.scene.stop("language").sendToBack();
		GAMEAPP.game.scene.start("menu").bringToTop();
		}, this);
		
		OR use new Phaser III feature: scene.transition
		
		this.scene.transition({  
			//allowInput: false,    // set true to enable input system  
									// of current scene and target scene
			data: {x: xxx, y: yyy}, // an object containing any data you wish  
									//passed into target scene init methods.  
			duration: 1000,     	// in milliseconds  
			//moveAbove: true,  	// move the target Scene to be above  
									//this current scene before the transition starts
			//moveBelow: true,  	// move the target Scene to be below  
									//this current scene before the transition starts
			//onUpdate: null,
			//onUpdateScope: scene,
			//sleep: false,     	// set true to sleep this scene,  
									// set false to stop this scene
			target: 'nextNewScene', // the key name to transition into
		});  
		*/
		
		GAMEAPP.game.scene.stop("story").sendToBack();
		console.log(" %c End background story.", "color:white; background:red");
		GAMEAPP.game.scene.start("menu").bringToTop();
		
};

/* End of file */
/* Location: ./js/state/story.js */
